// C++ system level
#include <string>
#include <cinttypes>

// ESP32 specific
// #include "esp_log.h"

// project specific
#include "CyanBusTX.hpp"

// qthing stuff
// #include ""


namespace SiliconTorch {

  namespace CyanBusInjector {

    extern const std::string BreakHeader;
    extern const std::string PacketHeader;


    class CyanBusInjector {
      public:
        CyanBusInjector(uint8_t tx, uint8_t rx, uint8_t de, uint8_t re, uint32_t baudRate = 115200, uint8_t uartChannel = 1);


        void setBaudRate(uint32_t baud);
        uint32_t getBaudRate();
        void publishBaudRate();

        std::string deviceTopic(const char *suffix);
        std::string serviceTopic(const char *suffix);
      private:

        CyanBusTX::CyanBusTX cbTX;
        // CyanBusTX::CyanBusTX* cbTX = NULL;


    };


    class CyanBusInjector_ProtoPCB : public CyanBusInjector {
      public:
        CyanBusInjector_ProtoPCB() : CyanBusInjector(23, 34, 32, 33) {};
    };

  }
}
